/*     */ import java.io.File;
/*     */ import java.io.PrintStream;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Random;
/*     */ 
/*     */ public class Game
/*     */ {
/*   6 */   private static String version = "1.3";
/*   7 */   public static boolean isRunning = false;
/*     */   public static GameMode mode;
/*     */   public static Difficulty diff;
/*  10 */   public static final Random r = new Random();
/*     */   private static boolean debug;
/*  12 */   private static ArrayList<Snake> snakes = new ArrayList();
/*     */   private static Console c;
/*     */   private static Window w;
/*     */   private static GamePanel gp;
/*  16 */   public static int score = 0;
/*  17 */   public static double prize = 100.0D;
/*  18 */   public static int speed = 0;
/*  19 */   private static String path = System.getenv("APPDATA") + "/.snake";
/*     */   private static long last;
/*     */   private long duration;
/*     */ 
/*     */   public static void main(String[] args)
/*     */   {
/*  24 */     new Game().run(args);
/*     */   }
/*     */   public void run(String[] args) {
/*  27 */     new File(path).mkdirs();
/*  28 */     gp = new GamePanel();
/*  29 */     w = new Window();
/*     */     int y;
/*  30 */     for (int x = 0; x < 64; x++) {
/*  31 */       for (y = 0; y < 64; y++) {
/*  32 */         if ((x == 0) || (y == 0) || (x == 63) || (y == 63)) {
/*  33 */           new Obstacle(x, y);
/*     */         }
/*     */       }
/*     */     }
/*  37 */     new MainMenu().show();
/*  38 */     last = System.nanoTime();
/*     */     while (true) {
/*  40 */       if ((Menu.getCurrentMenu() == null) || ((Menu.getCurrentMenu() instanceof GameOverMenu)) || ((Menu.getCurrentMenu() instanceof ScoreBoard))) {
/*  41 */         for (Snake s : snakes)
/*  42 */           s.move();
/*     */       }
/*  44 */       String title = "Snake version " + version;
/*  45 */       if (mode != GameMode.SURVIVAL) {
/*  46 */         if (snakes.size() == 1)
/*  47 */           title = title + " - Score: " + ((Snake)snakes.get(0)).getScore();
/*     */         else {
/*  49 */           for (Snake s : snakes)
/*  50 */             title = title + " - " + s.getName() + ": " + s.getScore();
/*     */         }
/*     */       }
/*  53 */       w.setTitle(title + ((mode == GameMode.SINGLEPLAYER) || (mode == GameMode.FOODHUNT) ? " +" + (int)prize : " by Raptilicus"));
/*  54 */       if ((prize > 0.0D) && ((Menu.getCurrentMenu() instanceof ScoreBoard)))
/*  55 */         prize -= 0.02D;
/*  56 */       gp.repaint();
/*  57 */       this.duration = (System.nanoTime() - last);
/*     */       try {
/*  59 */         if (this.duration < 6000000L) {
/*  60 */           int millis = 0;
/*  61 */           long nanos = this.duration;
/*  62 */           while (nanos >= 1000000L) {
/*  63 */             millis++;
/*  64 */             nanos -= 1000000L;
/*     */           }
/*     */ 
/*  67 */           Thread.sleep(6 - millis, (int)nanos);
/*     */         }
/*     */       } catch (Exception e) {
/*  70 */         e.printStackTrace();
/*     */       }
/*  72 */       last = System.nanoTime();
/*     */     }
/*     */   }
/*     */ 
/*     */   public static void start()
/*     */   {
/*  78 */     stop();
/*  79 */     switch ($SWITCH_TABLE$GameMode()[mode.ordinal()]) { case 2:
/*  80 */       snakes.add(new Snake("Player", 32, 32, 0)); break;
/*     */     case 3:
/*     */     case 4:
/*  82 */       snakes.add(new Snake("Player 1", 16, 48, 0)); snakes.add(new Snake("Player 2", 48, 16, 2)); break;
/*     */     default:
/*  83 */       return;
/*     */     }
/*  85 */     Menu.clearMenuStack();
/*  86 */     new MainMenu().show();
/*  87 */     isRunning = true;
/*  88 */     Food.newFood();
/*  89 */     prize = 100.0D;
/*  90 */     new ScoreBoard().show();
/*  91 */     System.out.println("Starting game with game mode " + mode);
/*     */   }
/*     */   public static void stop() {
/*  94 */     for (Snake s : snakes) {
/*  95 */       s.delete();
/*     */     }
/*  97 */     snakes.clear();
/*     */ 
/* 101 */     if (Food.f != null) {
/* 102 */       Food.f.delete();
/* 103 */       Food.f = null;
/*     */     }
/* 105 */     isRunning = false;
/*     */   }
/*     */   public static String getVersion() {
/* 108 */     return version; } 
/* 109 */   public static boolean isDebugging() { return debug; } 
/* 110 */   public static void setDebugging(boolean debug) { debug = debug; } 
/* 111 */   public static Console getConsole() { return c; } 
/* 112 */   public static Window getWindow() { return w; } 
/* 113 */   public static GamePanel getGamePanel() { return gp; } 
/* 114 */   public static void addPoints() { score = (int)(score + prize); prize = 100.0D; } 
/* 115 */   public static String getGameFolder() { return path; } 
/* 116 */   public static ArrayList<Snake> getSnakes() { return snakes; }
/*     */ 
/*     */   public static void increaseSpeed() {
/* 119 */     if (speed < 150)
/* 120 */       speed += 5;
/*     */   }
/*     */ 
/*     */   public static void exit() {
/* 124 */     (Menu.getCurrentMenu() instanceof MainMenu);
/* 125 */     System.out.println("Exiting ...");
/* 126 */     System.exit(0);
/*     */   }
/*     */ }

/* Location:           C:\Users\Leon\Desktop\Dropbox\Public\Games\Snake\Snake.jar
 * Qualified Name:     Game
 * JD-Core Version:    0.6.0
 */