import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.util.ArrayList;


public abstract class Button extends Label {

	private Color[][] mapMouseOver;
	public boolean mouseOver;
	private ArrayList<FontTile> tilesMouseOver = new ArrayList<FontTile>();

	public Button(String name, int x, int y) {
		super("Button_" + name, x, y);
		Image i = new javax.swing.ImageIcon(this.getClass().getResource("Button_" + name + ".png")).getImage();
		BufferedImage bi = new BufferedImage(i.getWidth(null), i.getHeight(null) / 2, BufferedImage.TYPE_INT_ARGB);
		Graphics g = bi.getGraphics();
		g.drawImage(i, 0, 0, i.getWidth(null), i.getHeight(null) / 2, 0, 0, i.getWidth(null), i.getHeight(null) / 2, null);
		g.dispose();
		map = getMap(bi);
		bi = new BufferedImage(i.getWidth(null), i.getHeight(null) / 2, BufferedImage.TYPE_INT_ARGB);
		g = bi.getGraphics();
		g.drawImage(i, 0, 0, i.getWidth(null), i.getHeight(null) / 2, 0, i.getHeight(null) / 2, i.getWidth(null), i.getHeight(null), null);
		g.dispose();
		mapMouseOver = getMap(bi);
		create();
	}
	
	public Button create() {
		super.create();
		tilesMouseOver.clear();
		Color[][] c = mapMouseOver;
		for(int x = 0; x < w; x++) {
			for(int y = 0; y < h; y++) {
				if(c[x][y] != null) {
					FontTile f = new FontTile(x + this.x, y + this.y);
					f.setColor(c[x][y]);
					tilesMouseOver.add(f);
				}
			}
		}
		return this;
	}
	public void delete() {
		
	}
	public abstract void onClick();
	public ArrayList<FontTile> getTiles() {return mouseOver? tilesMouseOver: tiles;}
}
