import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.Point;
import java.awt.TextArea;
import java.awt.TextField;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.io.OutputStream;
import java.io.PrintStream;
import java.text.SimpleDateFormat;
import java.util.Date;
import javax.swing.JFrame;
import javax.swing.JPanel;


class Console extends JFrame {

	private static final long serialVersionUID = 3044671937731188304L;
	private JPanel panel = new JPanel();
	static TextArea infoLabel = new TextArea();
	static TextField input = new TextField();
	private java.awt.Button submit = new java.awt.Button();
	@SuppressWarnings("unused")
	private static Console console;
	
	public Console() {
		super("Console for Trixie verion " + Game.getVersion());
		console = this;
		Dimension windowDim = new Dimension(800, 600);
		setMaximumSize(windowDim);
		setMinimumSize(new Dimension(0, 0));
		setPreferredSize(windowDim);
		setSize(windowDim);
		setLocationRelativeTo(null);
		setLocation(getX() + 400, getY());
		panel.setLayout(new BorderLayout(0, 0));
		add(panel);
		infoLabel.setText("Console for Trixie version " + Game.getVersion() + "\r\n");
		submit.setLabel("Submit");
		submit.setLocation(new Point(50, 50));
		submit.setBounds(50, 50, 50, 25);
		infoLabel.setBounds(0, 0, 785, 540);
		input.setBounds(0, 541, 786, 20);
		input.addKeyListener(new InputKeyListener());
		infoLabel.setEditable(false);
		setIconImage(new javax.swing.ImageIcon(getClass().getResource("icon.png")).getImage());
//		infoLabel
		panel.add(infoLabel);
		panel.add(input);
//		panel.add(submit);
		new ConsoleOutputStream();
		GraphicsDevice[] gds = GraphicsEnvironment.getLocalGraphicsEnvironment().getScreenDevices();
		if(gds.length > 1) {
			setLocation(new Point(gds[1].getDefaultConfiguration().getBounds().x, gds[1].getDefaultConfiguration().getBounds().y));
			setExtendedState(MAXIMIZED_BOTH);
		}
		System.out.println("Console initialized");
	}
	
	public void update() {
//		infoLabal.setBounds(0, 0, )
	}

	public void parseConsoleCommand(String command) {
		System.out.println("Parsing command: " + command);
		parseCommand(command);
	}
	public void parseCommand(String command) {
//		String[] cmd = command.toLowerCase().split(" ");
		
//		switch(cmd[0]) {
//			case "exit": case "close": case "quit": {
//				Game.exit();
//				return;
//			} case "console": {
//				if(cmd.length == 1 || cmd[1].equals("1") || cmd[1].equals("on") || cmd[1].equals("true")) {
//					console.setVisible(true);
//				} else if(cmd[1].equals("0") || cmd[1].equals("off") || cmd[1].equals("false")) {
//					console.setVisible(false);
//				} else System.out.println("Invalid arguments.");
//				return;
//			}
//			case "fps": case "showfps": {
//				if(cmd.length == 1)
//					Game.showFPS(!Game.showsFPS());
//				else if(cmd[1].equals("1") || cmd[1].equals("on") || cmd[1].equals("true")) {
//					Game.showFPS(true);
//				} else if(cmd[1].equals("0") || cmd[1].equals("off") || cmd[1].equals("false")) {
//					Game.showFPS(false);
//				} else {System.out.println("Invalid arguments."); return;}
//				System.out.println("FPS counter is now " + (Game.showsFPS()? "showing.":"hiding."));
//				return;
//			}
//			case "debug": {
//				if(cmd.length == 1) {
//					Game.setDebugging(!Game.isDebugging());
//					Game.showFPS(Game.isDebugging());
//				} else if(cmd[1].equals("1") || cmd[1].equals("on") || cmd[1].equals("true")) {
//					Game.setDebugging(true);
//					Game.showFPS(true);
//				} else if(cmd[1].equals("0") || cmd[1].equals("off") || cmd[1].equals("false")) {
//					Game.setDebugging(false);
//					Game.showFPS(false);
//				} else {
//					System.out.println("Invalid arguments.");
//					return;
//				}
//				return;
//			}
//		}
//		System.out.println("Unknown command.");
		
	}
	
	public boolean toggleConsole() {
		setVisible(!isVisible());
		Game.getGamePanel().requestFocus();
		return isVisible();
	}
	public void setVisible(boolean visible) {
		super.setVisible(visible);
		System.out.println("Console " + (isVisible()? "en":"dis") + "abled.");
	}
	
}

class InputKeyListener implements KeyListener {

	public void keyPressed(KeyEvent key) {
		if(key.getKeyCode() == KeyEvent.VK_ENTER) {
			String command = Console.input.getText();
			Console.input.setText("");
			command = command.replace("\r\n", "");
			while(command.contains("  ")) command = command.replace("  ", " ");
			if(command.startsWith(" ")) command = command.replaceFirst(" ", "");
			if(command.isEmpty()) return;
			Game.getConsole().parseConsoleCommand(command);
		}
	}

	public void keyReleased(KeyEvent arg0) {}

	public void keyTyped(KeyEvent key) {}
}




class ConsoleOutputStream extends OutputStream {
	boolean lineBreak = false;
	
	public ConsoleOutputStream(OutputStream arg0) {
		super();
	}
	private static final SimpleDateFormat format = new SimpleDateFormat("[HH:mm:ss]");
	
	public ConsoleOutputStream() {
		System.setOut(new ConsolePrintStream(this));
	}
	@Override
	public void write(int i) {}
	
	public void write(byte[] b) {
		String s = new String(b);
		if(s.replace("\r\n", "").isEmpty()) {
			lineBreak = true;
		} else {
//			s = Console.infoLabel.getText() + (lineBreak? "\r\n":"") + format.format(new Date()) + " " + s;
//			Console.infoLabel.setText(s);
			Console.infoLabel.append((lineBreak? "\r\n" + format.format(new Date()) + " ": "") + s);
			lineBreak = false;
//			Console.infoLabel.scrollToReference(s);
		}
	}
	
	public void write(byte[] b, int off, int len) {
		byte[] b2 = new byte[len];
		for(int i = 0; i < len; i++) {
			b2[i] = b[off + i];
		}
		write(b2);
//		write
	}
	
}

class ConsolePrintStream extends PrintStream {

	public ConsolePrintStream(OutputStream out) {
		super(out);
//		new PrintStream().
	}
}

