import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;


public class InputManager implements KeyListener, MouseListener, MouseMotionListener {
	private boolean mousePressed;
	public static Point mousePos = new Point();

	public void keyPressed(KeyEvent ke) {
		int key = ke.getKeyCode();
		if(key == KeyEvent.VK_ESCAPE) {
			if(Menu.getCurrentMenu() != null) Menu.getCurrentMenu().onClose();
			else new PauseMenu().show();
			return;
		}
		Snake s1, s2;
		if(Game.getSnakes().size() > 1) {
			s1 = Game.getSnakes().get(0);
			s2 = Game.getSnakes().get(1);
		} else if(Game.getSnakes().size() == 1) {
			s1 = Game.getSnakes().get(0);
			s2 = s1;
		} else {
			return;
		}
		switch(key) {
		case KeyEvent.VK_W:
			s1.setDir(0); break;
		case KeyEvent.VK_UP:
			s2.setDir(0); break;
		case KeyEvent.VK_D:
			s1.setDir(1); break;
		case KeyEvent.VK_RIGHT:
			s2.setDir(1); break;
		case KeyEvent.VK_S:
			s1.setDir(2); break;
		case KeyEvent.VK_DOWN:
			s2.setDir(2); break;
		case KeyEvent.VK_A:
			s1.setDir(3); break;
		case KeyEvent.VK_LEFT:
			s2.setDir(3); break;
		}
	}


	public void keyReleased(KeyEvent arg0) {}
	public void keyTyped(KeyEvent arg0) {}

	@Override
	public void mouseClicked(MouseEvent me) {}

	@Override
	public void mouseEntered(MouseEvent me) {
		
	}

	public void mouseExited(MouseEvent me) {
		mousePressed = false;
	}

	public void mousePressed(MouseEvent me) {
		if(me.getButton() == MouseEvent.BUTTON1 && !mousePressed) {
			if(Menu.getCurrentMenu() != null) {
				GamePanel gp = Game.getGamePanel();
				for(Button b: Menu.getCurrentMenu().getButtons()){
					if(new java.awt.Rectangle(b.x * (gp.bw + gp.sw) + gp.bx, b.y * (gp.bw + gp.sw) + gp.by, b.w * (gp.bw + gp.sw) - gp.sw, b.h * (gp.bw + gp.sw) - gp.sw).contains(me.getPoint())) {
						b.onClick();
					}
				}
			}
			mousePressed = true;
		}
	}

	public void mouseReleased(MouseEvent me) {
		if(me.getButton() == MouseEvent.BUTTON1)
			mousePressed = false;
	}
	

	public void mouseDragged(MouseEvent me) {
		mouseMoved(me);
	}


	public void mouseMoved(MouseEvent me) {
		mousePos = me.getPoint();
		if(Menu.getCurrentMenu() != null) {
			for(Button b: Menu.getCurrentMenu().getButtons()){
				b.mouseOver = isMouseOverButton(b);
			}
		}
	}
	
	public static boolean isMouseOverButton(Button b) {
		GamePanel gp = Game.getGamePanel();
		return new Rectangle(b.x * (gp.bw + gp.sw) + gp.bx, b.y * (gp.bw + gp.sw) + gp.by, b.w * (gp.bw + gp.sw) - gp.sw, b.h * (gp.bw + gp.sw) - gp.sw).contains(mousePos);
	}
	

}
