import java.util.ArrayList;

public class Snake {
	private int x, y, d, newd;
	private String name;
	private int score = 0;
	private int speed = 1;
	private int idle = 40;
	private ArrayList<Tail> tail = new ArrayList<Tail>();
	private boolean dead;
	public static final int UP = 0, RIGHT = 1, DOWN = 2, LEFT = 3;
	
	public Snake(String name, int x, int y, int d) {
		this.name = name;
		this.x = x;
		this.y = y;
		newd = d;
		for(int i = 0; i < 5; i++) {
			tail.add(new Tail(x, y, this));
		}
	}
	
	public void eat(Food f) {
		f.delete();
		Tail t1 = tail.get(0);
		Tail t2 = new Tail(t1.getX(), t1.getY(), this);
		t2.age = t1.age;
		tail.add(0, t2);
		Food.newFood();
		score += Game.prize;
		Game.prize = 100;
		if(speed < 30)
		speed += 1;
	}
	
	public void delete() {
		for(Tail t: tail) {
			t.delete();
		}
	}
	
	@SuppressWarnings("unchecked")
	public void move() {
		if(idle > speed) {idle -= 1; return;}
		idle = 40;
		d = newd;
		switch(d) {
		case 0: y--; break;
		case 1: x++; break;
		case 2: y++; break;
		case 3: x--; break;
		}
//		for(Tail t: tail) {
//			t.age++;
//			if(t.getX() == x && t.getY() == y) {
//				System.out.println(name + " crashed into " + t.);
//				kill();
//			}
//		}
		if(dead) {if(!tail.isEmpty()) tail.remove(0).delete(); return;}
		tail.get(0).setPos(x, y);
		tail.add(tail.remove(0));
//		for(int i = tail.size() - 1; i >= 0; i--) {
//			if(i != 0) {
//				tail.get(i).setPos(tail.get(i-1).getPos());
//			} else {
//				tail.get(i).setPos(x, y);
//			}
//		}
		for(Tile t: (ArrayList<Tile>) Tile.tiles.clone()) { //checks for collision
			if(tail.contains(t)) {
				((Tail) t).age++;
			}
			if(t.getX() == x && t.getY() == y) {
				if(t instanceof Food) {
					eat((Food) t);
				} else if(t instanceof Crashable && tail.get(tail.size() - 1) != t) {
					System.out.println(name + " crashed into " + t.getName());
					kill();
				}
			}
		}
	}
	
	public void kill() {
		setDir(-1);
		dead = true;
		if(Menu.getCurrentMenu() instanceof ScoreBoard && (Game.mode != GameMode.FOODHUNT || (Game.getSnakes().size() > 1 && Game.getSnakes().get(0).isDead() && Game.getSnakes().get(1).isDead()))) new GameOverMenu(this).show();
	}
	
	public boolean isDead() {return dead;}
	public ArrayList<Tail> getTail() {return tail;}
	public String getName() {return name;}
	public int getScore() {return score;}
	public void setDir(int d) {if(!dead && (d == -1 || d + 2 != this.d && d - 2 != this.d)) newd = d;}
}
