/*     */ import java.awt.Color;
/*     */ import java.awt.Graphics;
/*     */ import java.util.ArrayList;
/*     */ import javax.swing.JPanel;
/*     */ 
/*     */ public class GamePanel extends JPanel
/*     */   implements Runnable
/*     */ {
/*     */   private static final long serialVersionUID = 1552746400473185110L;
/*   8 */   InputManager im = new InputManager();
/*   9 */   int bw = getBoxWidth(); int sw = getSpanWidth(); int bx = getBorderX(); int by = getBorderY();
/*     */ 
/*     */   public GamePanel() {
/*  12 */     setBackground(Color.black);
/*  13 */     setFocusable(true);
/*  14 */     requestFocus();
/*  15 */     addKeyListener(this.im);
/*  16 */     addMouseListener(this.im);
/*  17 */     addMouseMotionListener(this.im);
/*     */   }
/*     */ 
/*     */   public void run()
/*     */   {
/*     */     while (true) {
/*  23 */       repaint();
/*     */       try {
/*  25 */         Thread.sleep(5L);
/*     */       } catch (InterruptedException e) {
/*  27 */         e.printStackTrace();
/*     */       }
/*     */     }
/*     */   }
/*     */ 
/*     */   public void paint(Graphics g)
/*     */   {
/*  34 */     super.paint(g);
/*  35 */     g.setColor(new Color(30, 30, 30));
/*  36 */     this.bw = getBoxWidth();
/*  37 */     this.sw = getSpanWidth();
/*  38 */     this.bx = getBorderX();
/*  39 */     this.by = getBorderY();
/*  40 */     for (int x = 0; x < 64; x++) {
/*  41 */       for (int y = 0; y < 64; y++) {
/*  42 */         g.fillRect(this.bx + x * (this.bw + this.sw), this.by + y * (this.bw + this.sw), this.bw, this.bw);
/*     */       }
/*     */     }
/*  45 */     Menu m = Menu.getCurrentMenu();
/*  46 */     if ((m instanceof ScoreBoard)) {
/*  47 */       for (Label l : m.getLabels()) {
/*  48 */         for (Tile t : l.getTiles()) {
/*  49 */           draw(t, g);
/*     */         }
/*     */       }
/*     */     }
/*  53 */     for (Tile t : Tile.tiles) {
/*  54 */       if (!(t instanceof Tail))
/*  55 */         draw(t, g);
/*     */     }
/*  57 */     for (Snake s : (ArrayList)Game.getSnakes().clone()) {
/*  58 */       for (Tail t : (ArrayList)s.getTail().clone()) {
/*  59 */         draw(t, g);
/*     */       }
/*     */     }
/*  62 */     if ((m != null) && (!(m instanceof ScoreBoard))) {
/*  63 */       for (Label l : m.getLabels()) {
/*  64 */         for (Tile t : l.getTiles()) {
/*  65 */           draw(t, g);
/*     */         }
/*     */       }
/*     */     }
/*  69 */     g.dispose();
/*  70 */     updateUI();
/*     */   }
/*     */ 
/*     */   private void draw(Tile t, Graphics g) {
/*  74 */     g.setColor(t.getColor());
/*  75 */     int x = t.getX(); int y = t.getY();
/*  76 */     g.fillRect(this.bx + x * (this.bw + this.sw), this.by + y * (this.bw + this.sw), this.bw, this.bw);
/*     */   }
/*     */ 
/*     */   private int getBoxWidth() {
/*  80 */     if (getWidth() < getHeight()) {
/*  81 */       return getWidth() / 64 - getSpanWidth();
/*     */     }
/*  83 */     return getHeight() / 64 - getSpanWidth();
/*     */   }
/*     */ 
/*     */   private int getSpanWidth()
/*     */   {
/*  88 */     if (getWidth() < getHeight()) {
/*  89 */       return getWidth() / 640;
/*     */     }
/*  91 */     return getHeight() / 640;
/*     */   }
/*     */ 
/*     */   private int getBorderX()
/*     */   {
/*  96 */     return (getWidth() - (getBoxWidth() + getSpanWidth()) * 64) / 2;
/*     */   }
/*     */ 
/*     */   private int getBorderY() {
/* 100 */     return (getHeight() - (getBoxWidth() + getSpanWidth()) * 64) / 2;
/*     */   }
/*     */ }

/* Location:           C:\Users\Leon\Desktop\Dropbox\Public\Games\Snake\Snake.jar
 * Qualified Name:     GamePanel
 * JD-Core Version:    0.6.0
 */