/*    */ import java.awt.Color;
/*    */ import java.awt.Graphics;
/*    */ import java.awt.Image;
/*    */ import java.awt.image.BufferedImage;
/*    */ import java.util.ArrayList;
/*    */ import java.util.HashMap;
/*    */ import javax.swing.ImageIcon;
/*    */ 
/*    */ public class Label
/*    */ {
/*    */   protected int x;
/*    */   protected int y;
/*    */   protected int w;
/*    */   protected int h;
/*    */   protected Color[][] map;
/* 12 */   protected ArrayList<FontTile> tiles = new ArrayList();
/* 13 */   protected static HashMap<String, Color[][]> maps = new HashMap();
/* 14 */   protected static HashMap<String, Label> labels = new HashMap();
/*    */ 
/*    */   public Label(String name, int x, int y) {
/* 17 */     this.x = x;
/* 18 */     this.y = y;
/* 19 */     this.map = getMap(name);
/* 20 */     if (!(this instanceof Button)) {
/* 21 */       create();
/*    */     }
/* 23 */     if (!labels.containsKey(name))
/* 24 */       labels.put(name, this);
/*    */   }
/*    */ 
/*    */   public Label create() {
/* 28 */     Color[][] c = this.map;
/* 29 */     this.tiles.clear();
/* 30 */     for (int x = 0; x < this.w; x++) {
/* 31 */       for (int y = 0; y < this.h; y++) {
/* 32 */         if (c[x][y] != null) {
/* 33 */           FontTile f = new FontTile(x + this.x, y + this.y);
/* 34 */           f.setColor(c[x][y]);
/* 35 */           this.tiles.add(f);
/*    */         }
/*    */       }
/*    */     }
/* 39 */     return this;
/*    */   }
/*    */ 
/*    */   public void delete() {
/* 43 */     for (FontTile t : this.tiles) {
/* 44 */       t.delete();
/*    */     }
/* 46 */     this.tiles.clear();
/*    */   }
/*    */ 
/*    */   protected Color[][] getMap(String name) {
/* 50 */     if (maps.containsKey(name)) return (Color[][])maps.get(name);
/* 51 */     Image i = new ImageIcon(getClass().getResource(name + ".png")).getImage();
/* 52 */     BufferedImage bi = new BufferedImage(i.getWidth(null), i.getHeight(null), 2);
/* 53 */     Graphics g = bi.getGraphics();
/* 54 */     g.drawImage(i, 0, 0, null);
/* 55 */     g.dispose();
/* 56 */     return getMap(bi);
/*    */   }
/*    */ 
/*    */   protected Color[][] getMap(BufferedImage i) {
/* 60 */     Color[][] map = new Color[this.w = i.getWidth(null)][this.h = i.getHeight(null)];
/* 61 */     for (int x = 0; x < this.w; x++) {
/* 62 */       for (int y = 0; y < this.h; y++) {
/* 63 */         map[x][y] = new Color(i.getRGB(x, y), true);
/*    */       }
/*    */     }
/* 66 */     return map;
/*    */   }
/* 68 */   public ArrayList<FontTile> getTiles() { return this.tiles;
/*    */   }
/*    */ }

/* Location:           C:\Users\Leon\Desktop\Dropbox\Public\Games\Snake\Snake.jar
 * Qualified Name:     Label
 * JD-Core Version:    0.6.0
 */